﻿jsx3.util.Logger.getLogger("org.isocat").info("Loading class[org.isocat.gui.DCViewer]");

/**
* The DC viewer
* @author Menzo.Windhouwer@mpi.nl
*/
jsx3.lang. Class.defineClass("org.isocat.gui.DCViewer", null,[], function (DCViewer, DCViewer_prototype) {
    
    /**
    * The class logger
    */
    DCViewer.log = jsx3.util.Logger.getLogger("org.isocat.gui.DCViewer");
    
    /**
    * The view block of the component
    */
    DCViewer_prototype.view;
    
    /**
    * The window of the component
    */
    DCViewer_prototype.window;
    
    /**
    * The view tabs
    */
    DCViewer_prototype.tabs;
    
    /**
    * The label
    */
    DCViewer_prototype.label;
    
    /**
    * The actual DC viewer
    */
    DCViewer_prototype.viewer;
    
    /**
    * The editButton
    */
    DCViewer_prototype.editButton;
    
    /**
    * The scopeButton
    */
    DCViewer_prototype.scopeButton;
    
    /**
    * The checkButton
    */
    DCViewer_prototype.checkButton;
    
    /**
    * The window button
    */
    DCViewer_prototype.windowButton;
    
    /**
    * The explore button
    */
    DCViewer_prototype.exploreButton;
    
    /**
    * The history button
    */
    DCViewer_prototype.historyButton;
    
    /**
    * The clone button
    */
    DCViewer_prototype.cloneButton;
    
    /**
    * The deprecate button
    */
    DCViewer_prototype.deprecateButton;
    
    /**
    * The like menu
    */
    DCViewer_prototype.likeMenu;
    
    /**
    * The view splitter
    */
    DCViewer_prototype.viewSplitter;
    DCViewer_prototype.splitPosition;
    
    /**
    * The check result view
    */
    DCViewer_prototype.checkView;
    
    /**
    * The check result viewer
    */
    DCViewer_prototype.checkResult;
    
    /**
    * The overlay
    */
    DCViewer_prototype.overlay;
    
    /**
    * The DC
    */
    DCViewer_prototype.dc;
    
    /**
    * The content DCS
    */
    DCViewer_prototype.dcs;
    
    /**
    * The DC scope
    */
    DCViewer_prototype._dc; // the DC class to access the scope, the use of this class should be broadened
    DCViewer_prototype._scope;
    
    /**
    * Constructor
    */
    DCViewer_prototype.init = function (view) {
        org.isocat.gui.DCViewer.log.info("initialize DC viewer[" + this + "]");
        
        this.view = view;
        org.isocat.gui.DCViewer.log.info("- DC viewer view[" + this.view + "]");
        this.window = null;
        org.isocat.gui.DCViewer.log.info("- DC viewer window[" + this.window + "]");
        this.tabs = this.view.getChild("tabbedpane");
        org.isocat.gui.DCViewer.log.info("- DC viewer tabs[" + this.tabs + "]");
        this.viewer = this.view.getDescendantOfName("DataCategoryView");
        org.isocat.gui.DCViewer.log.info("- DC text view[" + this.viewer + "]");
        this.editButton = this.view.getDescendantOfName("editButton");
        org.isocat.gui.DCViewer.log.info("- edit button[" + this.editButton + "]");
        this.scopeButton = this.view.getDescendantOfName("scopeButton");
        org.isocat.gui.DCViewer.log.info("- scope button[" + this.scopeButton + "]");
        this.checkButton = this.view.getDescendantOfName("checkButton");
        org.isocat.gui.DCViewer.log.info("- check button[" + this.checkButton + "]");
        this.exploreButton = this.view.getDescendantOfName("exploreButton");
        org.isocat.gui.DCViewer.log.info("- explore button[" + this.exploreButton + "]");
        this.historyButton = this.view.getDescendantOfName("historyButton");
        org.isocat.gui.DCViewer.log.info("- history button[" + this.historyButton + "]");
        this.cloneButton = this.view.getDescendantOfName("cloneButton");
        org.isocat.gui.DCViewer.log.info("- clone button[" + this.cloneButton + "]");
        this.deprecateButton = this.view.getDescendantOfName("deprecateButton");
        org.isocat.gui.DCViewer.log.info("- deprecate button[" + this.deprecateButton + "]");
        this.likeMenu = this.view.getDescendantOfName("likeMenu");
        org.isocat.gui.DCViewer.log.info("- like menu[" + this.likeMenu + "]");
        this.label = this.view.getDescendantOfName("label");
        org.isocat.gui.DCViewer.log.info("- label[" + this.label + "]");
        this.windowButton = this.view.getDescendantOfName("windowButton");
        org.isocat.gui.DCViewer.log.info("- window button[" + this.windowButton + "]");
        this.viewSplitter = this.view.getDescendantOfName("viewSplitter");
        if (this.viewSplitter.getSubcontainer1Pct() != "100") {
            this.viewSplitter.setSubcontainer1Pct("100", true);
        }
        this.splitPosition = "80";
        org.isocat.gui.DCViewer.log.info("- view splitter[" + this.viewSplitter + "]");
        this.checkView = this.view.getDescendantOfName("CheckResultView");
        org.isocat.gui.DCViewer.log.info("- check result view[" + this.checkView + "]");
        this.checkResult = this.view.getDescendantOfName("checkResult");
        org.isocat.gui.DCViewer.log.info("- check result viewer[" + this.checkResult + "]");
        this.overlay = this.view.getDescendantOfName("overlay");
        org.isocat.gui.DCViewer.log.info("- overlay[" + this.overlay + "]");
        
        this.dc = null;
        this.dcs = null;
        
        this._dc = null;
        this._scope = null;
        
        org.isocat.gui.DCViewer.log.info("initialized DC viewer[" + this + "]");
        
        this.view.controller = this;
        
        // subscribe to DC messages
        window.PageBus.subscribe("org.isocat.DC.*", this, this.handle, null);
        
        // subscribe to Scope messages
        window.PageBus.subscribe("org.isocat.Scope.*", this, this.handle, null);
        
        // publish the message using PageBus
        org.isocat.publish("org.isocat.gui.DCViewer.init", this);
    };
    
    /**
    * Event handler
    */
    DCViewer_prototype.handle = function (subject, message, subscriberData) {
        org.isocat.gui.DCViewer.log.info("handle event[" + subject + "]");
        
        if ((subject == "org.isocat.DC.reload") && (this.dc != null) && (message.body == this.dc.id)) {
            this.load();
            org.isocat.gui.DCViewer.log.info("reloaded DC[" + this.dc.id + "]");
            if (this.checkButton.getState() == jsx3.gui.ToolbarButton.STATEON) {
                this.check(true);
                org.isocat.gui.DCViewer.log.info("recheck DC[" + this.dc.id + "]");
            }
        } else if ((subject == "org.isocat.Scope.retrieved") && (message.body == this._scope)) {
            this.handleScope();
        } else if ((subject == "org.isocat.Scope.updated") && (message.body == this._scope)) {
            this.handleScope();
        }
        
        org.isocat.gui.DCViewer.log.info("handled event[" + subject + "]");
    }
    
    
    DCViewer_prototype.showDataCategory = function (dc, dcs) {
        this.dc = dc;
        this.dcs = dcs;
        
        org.isocat.gui.DCViewer.log.info("loading DC[" + this.dc.id + "] in the context of DCS[" + this.dcs + "]");
        
        // hide the overlay
        this.showOverlay(false);
        
        // toggle the check button
        if (this.checkButton.getState() == jsx3.gui.ToolbarButton.STATEON) {
            this.checkButton.setState(jsx3.gui.ToolbarButton.STATEOFF, true);
        }
        // hide the empty check result view
        if (this.viewSplitter.getSubcontainer1Pct() != "100") {
            this.splitPosition = this.viewSplitter.getSubcontainer1Pct();
            this.viewSplitter.setSubcontainer1Pct("100", true);
        }
        // clear the check results
        org.isocat.APP.getCache().setDocument("check-dc-" + this.dc.id, jsx3.xml.CDF.Document.newDocument());
        this.checkResult.setXMLId("check-dc-" + this.dc.id);
        this.checkResult.repaintData();
        
        // show the loading overlay
        org.isocat.gui.Loading.load(this.view, "Loading ...").show();
        org.isocat.gui.DCViewer.log.info("showing loading overlay?");
        
        // make the DC visible
        this.tabs.setSelectedIndex(1, true);
        
        // set the title
        var title = this.dc.name + " - " + this.dc.version;
        if (this.window == null) {
            this.label.setText(title, true);
        } else {
            this.window.getCaptionBar().setText(title, true);
        }
        
        // reset some buttons
        this.scopeButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        this.editButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        this.deprecateButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        this.likeMenu.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        /*
        if (org.isocat.profile.user() == 'guest') {
            this.cloneButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        } else {
            this.cloneButton.setEnabled(jsx3.gui.Form.STATEENABLED, true);
        }
        */
        this.cloneButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        
        // load the scope information
        this.loadScope();
        
        // set the correct check icon
        this.checkIcon();
        
        // can the user like a DC?
        this.fillLikeMenu();
        
        // load the DC content
        this.load();
    };
    
    DCViewer_prototype.load = function () {
        // load the DC content
        var uri = "http://isocat:8080/isocat/rest/dc/" + this.dc.id + ".html?html-title=none";
        if ((typeof (this.dcs) != 'undefined') && (this.dcs.type() == "profile" || this.dcs.type() == "dcs")) {
            uri += "&suppress=true";
            uri += "&suppress-context=" + this.dcs.id();
            uri += "&suppress-context-type=" + this.dcs.type();
        }
        org.isocat.gui.DCViewer.log.info("loading uri[" + uri + "]");
        
        var req = new jsx3.net.Request(new Date().getTime());
        req.open("GET", uri, true);
        req.subscribe(jsx3.net.Request.EVENT_ON_RESPONSE, this, this.loaded);
        req.subscribe(jsx3.net.Request.EVENT_ON_TIMEOUT, this, this.failed);
        
        req.send();
    };
    
    DCViewer_prototype.anchors = function (node, skip) {
        org.isocat.gui.DCViewer.log.info("anchors(node[" + node + "],skip[" + skip + "])");
        // DCs
        for (var iter = node.selectNodeIterator(".//a[@datcat]");iter.hasNext();) {
            var anchor = iter.next();
            var href = anchor.getAttribute("href");
            org.isocat.gui.DCViewer.log.info("anchor.href[" + href + "]");
            var id = anchor.getAttribute("datcat");;
            org.isocat.gui.DCViewer.log.info("anchor.href[" + href + "].datcat[" + id + "]");
            if (! skip || (id != this.dc.id)) {
                anchor.setAttribute("onclick", "javascript:org.isocat.showDataCategoryInViewer('" + id + "','" + this.view.getId() + "')");
                anchor.setAttribute("href", "#");
                anchor.setAttribute("target", null);
                org.isocat.gui.DCViewer.log.info("anchor[" + anchor + "]");
                // add an anchor to open the DC in a separate window
                var winanchor = new jsx3.xml.Document();
                winanchor.loadXML('<a href="#" onclick="javascript:org.isocat.showDataCategoryInWindow(\'' + id + '\')"><img border="0" src="http://isocat:8080/isocat/interface/JSXAPPS/ISOcat/images/window.png"/></a>');
                //winanchor = winanchor.getFirstChild();
                anchor.getParent().appendChild(winanchor);
            }
        }
        // groups
        for (var iter = node.selectNodeIterator(".//a[@group]");iter.hasNext();) {
            var anchor = iter.next();
            var href = anchor.getAttribute("href");
            org.isocat.gui.DCViewer.log.info("anchor.href[" + href + "]");
            var id = anchor.getAttribute("group");;
            org.isocat.gui.DCViewer.log.info("anchor.href[" + href + "].group[" + id + "]");
            anchor.setAttribute("onclick", "javascript:org.isocat.showGroupInWindow('" + id + "','" + this.view.getId() + "')");
            anchor.setAttribute("href", "#");
            anchor.setAttribute("target", null);
            org.isocat.gui.DCViewer.log.info("anchor[" + anchor + "]");
        }
    };
    
    DCViewer_prototype.resetView = function () {
        // close some sections
        $('.dc-' + this.dc.id + '-adminrec').toggle();
        $('.dc-' + this.dc.id + '-langsec').toggle();
        $('.dc-' + this.dc.id + '-langsec-en').addClass('dc-' + this.dc.id + '-langsec');
    };
    
    DCViewer_prototype.loaded = function (objEvent) {
        var req = objEvent.target;
        var doc = req.getResponseXML();
        
        if ((req.getStatus() != 200) || (doc == null)) {
            org.isocat.gui.DCViewer.log.info("DC request failed[" + req.getStatus() + "][" + doc + "][" + req.getResponseText() + "]");
            org.isocat.APP.alert("DC loading failed", "The DC couldn't be loaded! You might not have the right to access it (anymore).", null, "OK");
            
            // hide the loading overlay
            org.isocat.gui.Loading.load(this.view).hide();
            org.isocat.gui.DCViewer.log.info("hiding loading overlay?");
            
            this.reset();
            return;
        }
        
        org.isocat.gui.DCViewer.log.info("DC request succeeded[" + req.getStatus() + "]");
        
        var div = doc.selectSingleNode("//div[@class='main']");
        this.anchors(div, true);
        
        this.viewer.setText(div.toString(), true);
        this.viewer.getRendered().scrollTop = 0;
        this.viewer.getRendered().scrollLeft = 0;
        
        this.resetView();
        
        // hide the loading overlay
        org.isocat.gui.Loading.load(this.view).hide();
        org.isocat.gui.DCViewer.log.info("hiding loading overlay?");
        
        org.isocat.gui.DCViewer.log.info("showing DC[" + this.dc.id + "]");
    };
    
    DCViewer_prototype.failed = function (objEvent) {
        var req = objEvent.target;
        org.isocat.gui.DCViewer.log.info("DC request failed[" + req.getStatus() + "]");
    };
    
    DCViewer_prototype.addToBasket = function () {
        if (this.dc != null) {
            org.isocat.addToBasket(this.dc);
            org.isocat.gui.DCViewer.log.info("added DC[" + this.dc.id + "] to the basket");
        } else {
            org.isocat.gui.DCViewer.log.info("failed to add DC to the basket");
        }
    };
    
    DCViewer_prototype.edit = function () {
        org.isocat.editDataCategory(this.dc);
    };
    
    DCViewer_prototype.loadScope = function () {
        this._dc = new org.isocat.data.DC(this.dc.id);
        this._scope = this._dc.scope();
        if (this._scope != null) {
            this._scope.retrieve();
        }
    };
    
    DCViewer_prototype.handleScope = function () {
        // only the owner can edit the scope of the DC
        org.isocat.gui.DCViewer.log.info("dc.owner_id[" + this.dc.owner_id + "]org.isocat.profile.id[" + org.isocat.profile.id() + "]org.isocat.profile.type[" + org.isocat.profile.type() + "]");
        if (((this.dc.owner_id != 0) && (this.dc.owner_id == org.isocat.profile.id()))) {
            this.scopeButton.setEnabled(jsx3.gui.Form.STATEENABLED, true);
            //this.deprecateButton.setEnabled(jsx3.gui.Form.STATEENABLED, true);
        } else {
            this.scopeButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
            //this.deprecateButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        }
        
        // check if this user can edit the DC
        var rights = this._scope.getRights(org.isocat.profile.id());
        if (rights.indexOf('u') >= 0) {
            this.editButton.setEnabled(jsx3.gui.Form.STATEENABLED, true);
        } else {
            this.editButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);
        }
        
        // set the correct scope icon
        this.scopeIcon();
    };
    
    DCViewer_prototype.scopeIcon = function () {
        // set the correct scope icon
        var prop = "icon: scope " +(this._scope.getPublic() == 'r' ? 'public': 'private');
        if (org.isocat.APP.getProperties().containsKey(prop)) {
            this.scopeButton.setDynamicProperty("jsximage", prop, true)
            this.scopeButton.repaint();
        }
    };
    
    DCViewer_prototype.scope = function () {
        if (this._dc != null) {
            // show scope dialog
            var dialog = org.isocat.APP.getRootBlock().loadAndCache("components/Scope.xml", true).controller;
            dialog.showDataCategoryScope(this._dc);
        }
    };
    
    DCViewer_prototype.showOverlay = function (show, button, what) {
        if (typeof (this.overlay) == 'undefined') {
            return; // overlay is (still) unknown
        }
        if (typeof (this.overlay.getRendered()) == 'undefined') {
            return; // overlay has not yet been rendered
        }
        var main = this.overlay.getChild("main");
        var ebg = this.overlay.getChild("ebg");
        if (show) {
            if (this.exploreButton == button) {
                this.exploreButton.setState(jsx3.gui.ToolbarButton.STATEON, true);
            } else {
                this.exploreButton.setState(jsx3.gui.ToolbarButton.STATEOFF, true);
            }
            if (this.historyButton == button) {
                this.historyButton.setState(jsx3.gui.ToolbarButton.STATEON, true);
            } else {
                this.historyButton.setState(jsx3.gui.ToolbarButton.STATEOFF, true);
            }
            
            if (this.overlay.getDisplay() != jsx3.gui.Block.DISPLAYBLOCK) {
                this.overlay.setDisplay(jsx3.gui.Block.DISPLAYBLOCK, true);
            }
            
            main.setText("loading ...", true);
            
            this.loadOverlay(what);
            
            var d = this.viewer.getAbsolutePosition();
            var w = d.W;
            var h = d.H;
            
            ebg.setHeight(0, true);
            ebg.setWidth(w, true);
            
            main.setHeight(0, true);
            main.setWidth(w, true);
            
            var transition = com.bwalsh.gi.gui.Transition.Resize(w, h, ebg);
            transition.run();
            
            var transition = com.bwalsh.gi.gui.Transition.Resize(w, h, main);
            transition.run();
            
            org.isocat.gui.DCViewer.log.info("show overlay[width=" + w + ",height=" + h + "]");
        } else {
            var d = ebg.getAbsolutePosition();
            var w = d.W;
            var h = 0;
            
            if (d.H > 0) {
                //main.setText("");
                var overl = this.overlay;
                
                var transition = com.bwalsh.gi.gui.Transition.Resize(w, h, main);
                transition.run();
                
                transition = com.bwalsh.gi.gui.Transition.Resize(w, h, ebg);
                transition.setLastCallback(
                function () {
                    if (overl.getDisplay() != jsx3.gui.Block.DISPLAYNONE) {
                        overl.setDisplay(jsx3.gui.Block.DISPLAYNONE, true);
                    }
                });
                transition.run();
            } else {
                main.setText("");
                if (this.overlay.getDisplay() != jsx3.gui.Block.DISPLAYNONE) {
                    this.overlay.setDisplay(jsx3.gui.Block.DISPLAYNONE, true);
                }
            }
            
            this.exploreButton.setState(jsx3.gui.ToolbarButton.STATEOFF, true);
            this.historyButton.setState(jsx3.gui.ToolbarButton.STATEOFF, true);
        }
        return false;// we managed the toggle, cancel the event to prevent it from toggling again
    }
    
    DCViewer_prototype.loadOverlay = function (what) {
        // load the DC context content
        var id = 42;
        if (this.dc != null) {
            id = this.dc.id;
        }
        
        var uri = "http://isocat:8080/isocat/rest/dc/" + id + "/" + what + ".html";
        org.isocat.gui.DCViewer.log.info("loading uri[" + uri + "]");
        
        var req = new jsx3.net.Request(new Date().getTime());
        req.open("GET", uri, true);
        req.subscribe(jsx3.net.Request.EVENT_ON_RESPONSE, this, this.loadedOverlay);
        req.subscribe(jsx3.net.Request.EVENT_ON_TIMEOUT, this, this.failedOverlay);
        
        req.send();
    };
    
    DCViewer_prototype.loadedOverlay = function (objEvent) {
        var req = objEvent.target;
        var doc = req.getResponseXML();
        
        var div = doc.selectSingleNode("//div[@class='main']");
        this.anchors(div, false);
        
        this.overlay.getChild("main").setText(div.toString(), true);
        
        this.overlay.getRendered().scrollTop = 0;
        this.overlay.getRendered().scrollLeft = 0;
    };
    
    DCViewer_prototype.failedOverlay = function (objEvent) {
        // TODO: what should we do?
    };
    
    DCViewer_prototype.check = function (show) {
        if (show) {
            // show the check result view
            
            if (this.viewSplitter.getSubcontainer1Pct() == "100") {
                this.viewSplitter.setSubcontainer1Pct(this.splitPosition, true);
            }
            
            // load the loading overlay
            org.isocat.gui.Loading.load(this.checkView, "Checking ...").show();
            
            // request the check
            var uri = "http://isocat:8080/isocat/rest/dc/" + this.dc.id + "/check";
            org.isocat.asyncLoadDynamicCDFDocument(new jsx3.net.URI(uri), "Check2CDF_xsl", null, "check-dc-" + this.dc.id, this, this.checked);
        } else {
            // hide the check result view
            if (this.viewSplitter.getSubcontainer1Pct() != "100") {
                this.splitPosition = this.viewSplitter.getSubcontainer1Pct();
                this.viewSplitter.setSubcontainer1Pct("100", true);
            }
        }
    };
    
    DCViewer_prototype.checked = function (doc, req) {
        org.isocat.gui.Loading.load(this.checkView).hide();
        if (doc != null) {
            this.checkResult.setXMLId("check-dc-" + this.dc.id);
            this.checkResult.repaintData();
            
            // determine the check result
            this.dc.check = req.getResponseXML().selectSingleNode('/check/@result').getValue();
            
            // update the check icon
            this.checkIcon();
        } else {
            // hide the check result view
            if (this.viewSplitter.getSubcontainer1Pct() != "100") {
                this.viewSplitter.setSubcontainer1Pct("100", true);
            }
            org.isocat.gui.DCViewer.log.info("The DC check call failed. The HTTP Status code is: " + req.getStatus());
            org.isocat.APP.alert("DC checking failed", "The DC couldn't be checked! Contact the ISOcat system administrator.", null, "OK");
        }
    };
    
    DCViewer_prototype.checkIcon = function () {
        // set the correct check icon
        if (typeof (this.dc.check) != 'undefined') {
            var prop = "icon: check " + this.dc.check;
            if (org.isocat.APP.getProperties().containsKey(prop)) {
                this.checkButton.setDynamicProperty("jsximage", prop, true)
                this.checkButton.repaint();
            }
        }
    };
    
    DCViewer_prototype.print = function () {
        org.isocat.gui.DCViewer.log.info("print DC[" + this.dc.id + "]");
        
        var uri = "http://isocat:8080/isocat/rest/dc/" + this.dc.id + ".html?purpose=print";
        if ((typeof (this.dcs) != 'undefined') && (this.dcs.type() == "profile" || this.dcs.type() == "dcs")) {
            uri += "&suppress=true";
            uri += "&suppress-context=" + this.dcs.id();
            uri += "&suppress-context-type=" + this.dcs.type();
        }
        
        self.open(uri, "ISOcatPrint");
    };
    
    DCViewer_prototype.clone = function () {
        org.isocat.gui.DCViewer.log.info("clone DC[" + this.dc.id + "]");
    };
    
    DCViewer_prototype.deprecate = function () {
        org.isocat.gui.DCViewer.log.info("deprecate DC[" + this.dc.id + "]");
    };
    
    DCViewer_prototype.fillLikeMenu = function() {
        if (org.isocat.profile.user() != 'guest') {
            var menu = jsx3.xml.CDF.Document.newDocument();
            var cnt = 0;
            // grp should be owned by me
            for (var iter = org.isocat.profile.ws().doc.selectNodeIterator("//record[@type='private']/record[@type='group']");iter.hasNext();) {
				var grp = iter.next();
				// grp size should be 5 or more
				if (parseInt(grp.getAttribute("size")) >= 5) {
				    // grp should be public
				    if (org.isocat.profile.ws().doc.selectSingleNode("//record[@type='public']/record[@id='"+grp.getAttribute("id")+"']") != null ) {
				        var item = new Object();
				        item.jsxid = grp.getAttribute("id");
				        item.jsxtext = grp.getAttribute("jsxtext");
				        menu.insertRecord(item);
				        cnt++;
				    }
			    }
			}
			if (cnt>0) {
			    org.isocat.APP.getCache().setDocument(this.view.getId()+'-like',menu);
			    this.likeMenu.setXMLId(this.view.getId()+'-like');
			    this.likeMenu.setEnabled(jsx3.gui.Form.STATEENABLED, true);
			}
        }
    };
    
    DCViewer_prototype.like = function(grp) {
		var uri = "http://isocat:8080/isocat/rest/group/"+grp+"/recommends/dc/"+this.dc.id;
		var req = jsx3.net.Request.open("GET",uri,false);
		req.send();
		org.isocat.gui.DCViewer.log.info("group["+grp+"] recommends DC[" + this.dc.id + "]: "+uri+" -> "+req.getStatus());
		if (req.getStatus()==200) {
		  this.load();
		}
    };
    
    DCViewer_prototype.reset = function () {
        // make the no DC visible
        this.tabs.setSelectedIndex(0, true);
    };
    
    DCViewer_prototype.setWindow = function (window) {
        var title = this.dc.name + " - " + this.dc.version;
        this.window = window;
        if (window != null) {
            this.label.setText("", true);
            this.window.getCaptionBar().setText(title, true);
            this.windowButton.setEnabled(jsx3.gui.Form.STATEDISABLED, true);;
        } else {
            this.label.setText(title, true);
            this.windowButton.setEnabled(jsx3.gui.Form.STATEENABLED, true);;
        }
    };
});